// Copyright (c) 2025 Tigera, Inc. All rights reserved.

// Code generated by client-gen. DO NOT EDIT.

package v3

import (
	context "context"

	projectcalicov3 "github.com/projectcalico/api/pkg/apis/projectcalico/v3"
	scheme "github.com/projectcalico/api/pkg/client/clientset_generated/clientset/scheme"
	v1 "k8s.io/apimachinery/pkg/apis/meta/v1"
	types "k8s.io/apimachinery/pkg/types"
	watch "k8s.io/apimachinery/pkg/watch"
	gentype "k8s.io/client-go/gentype"
)

// BGPPeersGetter has a method to return a BGPPeerInterface.
// A group's client should implement this interface.
type BGPPeersGetter interface {
	BGPPeers() BGPPeerInterface
}

// BGPPeerInterface has methods to work with BGPPeer resources.
type BGPPeerInterface interface {
	Create(ctx context.Context, bGPPeer *projectcalicov3.BGPPeer, opts v1.CreateOptions) (*projectcalicov3.BGPPeer, error)
	Update(ctx context.Context, bGPPeer *projectcalicov3.BGPPeer, opts v1.UpdateOptions) (*projectcalicov3.BGPPeer, error)
	Delete(ctx context.Context, name string, opts v1.DeleteOptions) error
	DeleteCollection(ctx context.Context, opts v1.DeleteOptions, listOpts v1.ListOptions) error
	Get(ctx context.Context, name string, opts v1.GetOptions) (*projectcalicov3.BGPPeer, error)
	List(ctx context.Context, opts v1.ListOptions) (*projectcalicov3.BGPPeerList, error)
	Watch(ctx context.Context, opts v1.ListOptions) (watch.Interface, error)
	Patch(ctx context.Context, name string, pt types.PatchType, data []byte, opts v1.PatchOptions, subresources ...string) (result *projectcalicov3.BGPPeer, err error)
	BGPPeerExpansion
}

// bGPPeers implements BGPPeerInterface
type bGPPeers struct {
	*gentype.ClientWithList[*projectcalicov3.BGPPeer, *projectcalicov3.BGPPeerList]
}

// newBGPPeers returns a BGPPeers
func newBGPPeers(c *ProjectcalicoV3Client) *bGPPeers {
	return &bGPPeers{
		gentype.NewClientWithList[*projectcalicov3.BGPPeer, *projectcalicov3.BGPPeerList](
			"bgppeers",
			c.RESTClient(),
			scheme.ParameterCodec,
			"",
			func() *projectcalicov3.BGPPeer { return &projectcalicov3.BGPPeer{} },
			func() *projectcalicov3.BGPPeerList { return &projectcalicov3.BGPPeerList{} },
		),
	}
}
