// Copyright (c) 2025 Tigera, Inc. All rights reserved.

// Code generated by client-gen. DO NOT EDIT.

package v3

import (
	context "context"

	projectcalicov3 "github.com/projectcalico/api/pkg/apis/projectcalico/v3"
	scheme "github.com/projectcalico/api/pkg/client/clientset_generated/clientset/scheme"
	v1 "k8s.io/apimachinery/pkg/apis/meta/v1"
	types "k8s.io/apimachinery/pkg/types"
	watch "k8s.io/apimachinery/pkg/watch"
	gentype "k8s.io/client-go/gentype"
)

// StagedNetworkPoliciesGetter has a method to return a StagedNetworkPolicyInterface.
// A group's client should implement this interface.
type StagedNetworkPoliciesGetter interface {
	StagedNetworkPolicies(namespace string) StagedNetworkPolicyInterface
}

// StagedNetworkPolicyInterface has methods to work with StagedNetworkPolicy resources.
type StagedNetworkPolicyInterface interface {
	Create(ctx context.Context, stagedNetworkPolicy *projectcalicov3.StagedNetworkPolicy, opts v1.CreateOptions) (*projectcalicov3.StagedNetworkPolicy, error)
	Update(ctx context.Context, stagedNetworkPolicy *projectcalicov3.StagedNetworkPolicy, opts v1.UpdateOptions) (*projectcalicov3.StagedNetworkPolicy, error)
	Delete(ctx context.Context, name string, opts v1.DeleteOptions) error
	DeleteCollection(ctx context.Context, opts v1.DeleteOptions, listOpts v1.ListOptions) error
	Get(ctx context.Context, name string, opts v1.GetOptions) (*projectcalicov3.StagedNetworkPolicy, error)
	List(ctx context.Context, opts v1.ListOptions) (*projectcalicov3.StagedNetworkPolicyList, error)
	Watch(ctx context.Context, opts v1.ListOptions) (watch.Interface, error)
	Patch(ctx context.Context, name string, pt types.PatchType, data []byte, opts v1.PatchOptions, subresources ...string) (result *projectcalicov3.StagedNetworkPolicy, err error)
	StagedNetworkPolicyExpansion
}

// stagedNetworkPolicies implements StagedNetworkPolicyInterface
type stagedNetworkPolicies struct {
	*gentype.ClientWithList[*projectcalicov3.StagedNetworkPolicy, *projectcalicov3.StagedNetworkPolicyList]
}

// newStagedNetworkPolicies returns a StagedNetworkPolicies
func newStagedNetworkPolicies(c *ProjectcalicoV3Client, namespace string) *stagedNetworkPolicies {
	return &stagedNetworkPolicies{
		gentype.NewClientWithList[*projectcalicov3.StagedNetworkPolicy, *projectcalicov3.StagedNetworkPolicyList](
			"stagednetworkpolicies",
			c.RESTClient(),
			scheme.ParameterCodec,
			namespace,
			func() *projectcalicov3.StagedNetworkPolicy { return &projectcalicov3.StagedNetworkPolicy{} },
			func() *projectcalicov3.StagedNetworkPolicyList { return &projectcalicov3.StagedNetworkPolicyList{} },
		),
	}
}
